
var langs_with_pos = [ "en","de","pt","da","nl", "sv" ];

var langs_without_pos = [
    "af","ar","bg","bn","cs","el","es","et","fa","fi","fr","he","hi","hr","hu",
    "id","it","ja","kn","ko","lt","lv","mk","ml","mr","ne","no","pa","pl",
    "ro","ru","sk","sl","so","sq","sv","sw","ta","te","th","tl","tr",
    "uk","ur","vi","zh-cn","zh-tw" ];

var num_rows = 20;

function lang_pos_toggle(event) {
    var $this =$(this);
    var checked_state = $this.prop("checked");

    var id = $this.attr("id");
    var split_id = id.split("-");
    var related_id = split_id[0] + "-pos-choice";

    var disable_state = !checked_state;
    $('#'+related_id + " *").prop('disabled',disable_state);
}

function ajax_error(jqXHR, textStatus, errorThrown) {
    alert('An error occurred... Look at the console (F12 or Ctrl+Shift+I, Console tab) for more information!');

    console.log('jqXHR:' + jqXHR);
    console.log('textStatus:' + textStatus);
    console.log('errorThrown:' + errorThrown);
}		


function add_titles(json_data) {
    $.each( json_data, function( htid_with_prefix, htid_val ) {
	var htid = htid_with_prefix.replace(/^htid:/,"");
	
	$.each(htid_val.records, function( internalid, metadata ) {
	    var title = metadata.titles[0];
	    $("[name='"+htid+"']").each(function() {$(this).html(title)});
	    console.log(htid + ", title = " + metadata.titles[0]);
	});
    });
}

function show_new_results(delta)
{
    $('.search-in-progress').css("cursor","wait");

    var start = parseInt(store_search_args.start)
    
    store_search_args.start = start + parseInt(delta);
        
    $.ajax({
	type: 'GET',
	url: store_search_action,
	data: store_search_args,
	dataType: 'json',
	success: show_results,
	error: ajax_error
    });
}

function generate_item(line,id,id_pages)
{
    var css_class = (line%2 == 0) ? 'class="evenline"' : 'class="oddline"';
    
    var html_item = "";

    var id_pages_len = id_pages.length;
    
    for (var pi=0; pi<id_pages_len; pi++) {
	var page = id_pages[pi];
	
	var seqnum = (page==0) ? 1 : page;
	var babel_url = "https://babel.hathitrust.org/cgi/pt?id="+id+";view=1up;seq="+seqnum;

	if (id_pages_len>1) {

	    if (pi==0) {
		html_item += '<p ' + css_class + '>';
		html_item += '<span style="font-style: italic;" name="'
		             +id+'"><span style="cursor: progress;">Loading ...</span></span><br>';
		if (page > 0) {
		    html_item += id + ': <a target="_blank" href="' + babel_url + '">seq ' + seqnum + '</a> ';
		}
		else {
		    // skip linking to the 'phony' page 0
		    html_item += id;
		}
	    }
	    else {
		html_item += ', <a target="_blank" href="' + babel_url + '">seq ' + seqnum + '</a> ';
	    }
	}
	else {
	    html_item += '<p ' + css_class + '>';
	    html_item += ' <span style="font-style: italic;" name="'
		         +id+'"><span style="cursor: progress;">Loading ...</span></span><br>';

	    if (page > 0) {
		html_item += '<a target="_blank" href="' + babel_url + '">' + id + ', seq ' + seqnum + '</a>';
	    }
	    else {
		html_item += '<a target="_blank" href="' + babel_url + '">' + id + ', all pages</a>';
	    }
	    
	    html_item += '</p>';
	}
	
    }

    if (id_pages_len>1) {
	html_item += "</p>";
    }

    return html_item;
}



function show_results(jsonData) {
    var response = jsonData.response;
    var num_found = response.numFound;
    var docs = response.docs;
    var num_docs = docs.length;

    $('.search-in-progress').css("cursor","auto");
    
    var $search_results = $('#search-results');

    if (num_docs>0) {
	$search_results.html("<p>Results: " + num_found + " pages matched</p>");
	var from = parseInt(store_search_args.start);
	var to = from + num_rows;
	$search_results.append("<p>Showing matches: "+from+"-" + to + "</p>");
    }
    else {
	$search_results.html("<p>No pages matched your query</p>");
    }

    // Example form of URL
    //   https://babel.hathitrust.org/cgi/pt?id=hvd.hnnssu;view=1up;seq=11

    var htids = [];

    var prev_id = null;
    var prev_pages = [];
    
    var i=0;
    var line_num = 0;
    while (i<num_docs) {
	var doc = docs[i];
	var id_and_page = doc.id.split(".page-");
	var id = id_and_page[0];
	var seqnum;
	if (id_and_page.length>1) {
	    seqnum = parseInt(id_and_page[1]) +1; // fix up ingest error
	}
	else {
	    seqnum = 0;
	}
	var page = seqnum;

	if ((prev_id != null) && (id != prev_id)) {
	    // time to output previous item
	    var html_item = generate_item(line_num,prev_id,prev_pages);
	    $search_results.append(html_item);
	    line_num++;
	    prev_pages = [page];
	}
	else {
	    // accumulate pages
	    prev_pages.push(page)
	}
	
	htids.push("htid:"+id);

	prev_id = id;
	i++;
    }
    
    var html_item = generate_item(line_num,prev_id,prev_pages);
    $search_results.append(html_item);

    
    document.location.href="#search-results-anchor";
    
    var next_prev = '<p style="width:100%;"><div id="search-prev" style="float: left;"><a>&lt; Previous</a></div><div id="search-next" style="float: right;"><a>Next &gt;</a></div></p>';
    
    $search_results.append(next_prev);
    $('#search-prev').click(function(event) { show_new_results(-1*num_rows); });
    $('#search-next').click(function(event) { show_new_results(num_rows); });

    var search_start = store_search_args.start;
    if (search_start==0) {
	$('#search-prev').hide();
    }
    
    // Example URL for catalog metadata (multiple items)
    //   http://catalog.hathitrust.org/api/volumes/brief/json/id:552;lccn:70628581|isbn:0030110408

    var htids_str = htids.join("|",htids);
    var cat_url = "http://catalog.hathitrust.org/api/volumes/brief/json/" + htids_str;
    	$.ajax({
	    url: cat_url,
	    dataType: 'jsonp',
	    jsonpCallback: "add_titles"
	});
}

var store_search_args = null;
var store_search_action = null;

var group_by_vol_checked = 0;

function expand_vfield(q_term,all_vfields)
{
    var vfields = [];
    var metadata_fields = [  "accessProfile_t", "genre_t", "imprint_t", "isbn_t", "issn_t",
			     "issuance_t", "language_t", "lccn_t", "names_t", "oclc_t",
			     "pubPlace_t", "pubDate_t", "rightsAttributes_t", "title_t", "typeOfResource_t"  ];
    
    if (all_vfields) {
	for (var fi=0; fi<metadata_fields.length; fi++) {
	    var vfield = metadata_fields[fi];
	    vfields.push(vfield+":"+q_term);
	}
    }
    else {
	if (q_term.match(/:/)) {
	    vfields.push(q_term);
	}
	else {
	    // make searching by title the default
	    vfields.push("title_t:"+q_term);
	}
    }
    

    var vfields_str = vfields.join(" OR ");
    
    return vfields_str;
}

function expand_vquery_field_and_boolean(query,all_vfields)
{
    // boolean terms
    //  => pos and lang field
    if (query === "") { return "" }
    
    var query_terms = query.split(/\s+/);
    var query_terms_len = query_terms.length;

    var bool_query_term = [];

    var i=0;
    var prev_bool = "";

    for (var i=0; i<query_terms_len; i++) {
	var term = query_terms[i];
	if (term.match(/^(and|or)$/i)) {
	    prev_bool = term.toUpperCase();	    
	}
	else {
	    if (i>0) {
		if (prev_bool == "") {
		    prev_bool = "AND";
		}
	    }
	    
	    var expanded_term = expand_vfield(term,all_vfields); // **** only difference to POS version
	    
	    term = "(" + expanded_term + ")";

	    if (prev_bool != "") {
		bool_query_term.push(prev_bool);
		prev_bool = "";
	    }
	    bool_query_term.push(term);
	}
    }

    var bool_query = bool_query_term.join(" ");

    return bool_query;
}


function expand_field_lang_pos(q_text,langs_with_pos,langs_without_pos,search_all_checked)
{
    var fields = [];
    var universal_pos_tags = [ "VERB", "NOUN", "ADJ", "ADV", "ADP", "CONJ", "DET", "NUM", "PRT", "X" ];
    
    for (var li=0; li<langs_with_pos.length; li++) {
	var lang = langs_with_pos[li];
	var lang_enabled_id = lang + "-enabled";
	var $lang_enabled_cb = $('#'+lang_enabled_id);
	if ($lang_enabled_cb.is(':checked')) {
	    console.log("Extracting POS tags for: " + lang);
	    
	    for (var ti=0; ti<universal_pos_tags.length; ti++) {
		var tag = universal_pos_tags[ti];
		var lang_tag_id = lang+"-"+tag+"-htrctoken-cb";
		var $lang_tag_cb = $('#'+lang_tag_id);
		if (search_all_checked || ($lang_tag_cb.is(':checked'))) {		    
		    var lang_tag_field = lang+"_"+tag+"_htrctoken";
		    fields.push(lang_tag_field+":"+q_text);
		}
	    }
	}
    }

    for (var li=0; li<langs_without_pos.length; li++) {
	var lang = langs_without_pos[li];
	var lang_enabled_id = lang + "-enabled";
	var $lang_enabled_cb = $('#'+lang_enabled_id);

	if (search_all_checked || ($lang_enabled_cb.is(':checked'))) {
	    console.log("Adding in non-POS field for: " + lang);
	    var lang_tag_field = lang+"_htrctoken";
	    fields.push(lang_tag_field+":"+q_text);	    
	}
    }

    var fields_str = fields.join(" OR ");
    
    return fields_str;
}

function expand_query_field_and_boolean(query,langs_with_pos,langs_without_pos,search_all_checked)
{
    // boolean terms
    //  => pos and lang field
    if (query === "") { return "" }
    
    var query_terms = query.split(/\s+/);
    var query_terms_len = query_terms.length;

    var bool_query_term = [];

    var i=0;
    var prev_bool = "";

    for (var i=0; i<query_terms_len; i++) {
	var term = query_terms[i];
	if (term.match(/^(and|or)$/i)) {
	    prev_bool = term.toUpperCase();	    
	}
	else {
	    if (i>0) {
		if (prev_bool == "") {
		    prev_bool = "AND";
		}
	    }
	    
	    var expanded_term = expand_field_lang_pos(term,langs_with_pos,langs_without_pos,search_all_checked)
	    
	    term = "(" + expanded_term + ")";

	    if (prev_bool != "") {
		bool_query_term.push(prev_bool);
		prev_bool = "";
	    }
	    bool_query_term.push(term);
	}
    }

    var bool_query = bool_query_term.join(" ");

    return bool_query;
}


function submit_action(event)
{
    event.preventDefault();

    $('.search-in-progress').css("cursor","wait");
    
    store_search_action = $('#search-form').attr("action");
    
    var arg_indent = $('#indent').attr('value');
    var arg_wt     = $('#wt').attr('value');
    var arg_start  = $('#start').attr('value');
    var arg_rows   = $('#rows').attr('value');

    var q_text     = $('#q').val();
    var vq_text     = $('#vq').val();
    
    group_by_vol_checked = $('#group-results-by-id:checked').length;

    var search_all_langs_checked = $('#search-all-langs:checked').length;
    var search_all_vfields_checked = $('#search-all-vfields:checked').length;
    
    if ((q_text === "") && (vq_text === "")) {
	$('.search-in-progress').css("cursor","auto");
	alert("No query term(s) entered");
	return;
    }

    arg_vq = expand_vquery_field_and_boolean(vq_text,search_all_vfields_checked);
    
    arg_q = expand_query_field_and_boolean(q_text,langs_with_pos,langs_without_pos,search_all_langs_checked);

    //console.log("*** arg_vq = " + arg_vq);
    //console.log("*** arg_q = " + arg_q);
    
    if (arg_q == "") {
	if (arg_vq == "") {
	    // arg_vq was empty to start with, but attempt to expand non-empty arg_q
	    //   lead to an empty arg_q being returned
	    $('.search-in-progress').css("cursor","auto");
	    alert("No languages selected");
	    return;
	}
	else {
	    arg_q = arg_vq;
	}
    }
    else {
	if (arg_vq != "") {
	    // join the two with an AND
	    arg_q = "(" + arg_vq + ")" + " OR " + "(" + arg_q + ")";

	    // also implies
	    group_by_vol_checked = true;
	}
    }

    //console.log("*** NOW arg_q = " + arg_q);
    
    // Example search on one of the htrc-full-ef fields is: 
    //  q=en_NOUN_htrctoken:farming
    
    store_search_args = { q: arg_q, indent: arg_indent, wt: arg_wt, start: arg_start, rows: arg_rows };

    if (group_by_vol_checked) {
	store_search_args.sort="id asc";
    }
    
    
    $.ajax({
	type: 'GET',
	url: store_search_action,
	data: store_search_args,
	dataType: 'json',
	success: show_results,
	error: ajax_error
    });

}

function generate_pos_langs()
{
    var pos_checkbox = [
	{ pos:"VERB", label:"Verbs",       tooltip:"Verbs (all tenses and modes)" },
	{ pos:"NOUN", label:"Nouns",       tooltip:"Nouns (common and proper)" },
	{ pos:"ADJ",  label:"Adjectives",  tooltip: null }, 
	{ pos:"ADV",  label:"Adverbs",     tooltip: null },
	{ pos:"ADP",  label:"Adpositions", tooltip:"Adpositions (prepositions and postpositions)" },
	{ pos:"CONJ", label:"Conjunctions",tooltip: null },
	{ pos:"DET",  label:"Determiners", tooltip: null },
	{ pos:"NUM",  label:"Numbers",     tooltip:"Cardinal numbers" },
	{ pos:"PRT",  label:"Particles",   tooltip:"Particles or other function words" },
	{ pos:"X",    label:"Other",       tooltip:"Other words, such as foreign words, typos, abbreviations"}
    ];

    var $pos_fieldsets = $('#pos-fieldsets');
    
    for (var li=0; li<langs_with_pos.length; li++) {

	var l = langs_with_pos[li];
	var lang_full = isoLangs[l].name;
	var lang_native_full = isoLangs[l].nativeName;
	var opt_title = (lang_full !== lang_native_full) ? 'title="'+lang_native_full+'"' : "";

	var opt_enabled = (l == "en") ? 'checked="checked"' : "";
	
	var legend = "";
	legend += '    <legend style="margin-bottom: 5px; padding-top: 15px;">\n';
	legend += '      <input type="checkbox" name="'+l+'-enabled" id="'+l+'-enabled" ' + opt_enabled +'/>\n';
	legend += '      <span ' + opt_title + '>'+lang_full+':</span>\n';
	legend += '    </legend>\n';
	

	var check_box_list = [];
	    
	for (var pi=0; pi<pos_checkbox.length; pi++) {
	    var pos_info = pos_checkbox[pi];
	    var pos = pos_info.pos;
	    var label = pos_info.label;
	    var tooltip = pos_info.tooltip;
	    var opt_tooltip = (tooltip != null) ? 'title="'+tooltip+'"' : "";
	    
	    var check_box = "";
	    check_box += '    <input type="checkbox" name="'+l+'-'+pos+'-htrctoken-cb" id="'+l+'-'+pos+'-htrctoken-cb" checked="checked" />\n';
	    check_box += '    <label for="'+l+'-'+pos+'-htrctoken-cb" '+opt_tooltip+'>'+label+'</label>\n';

	    check_box_list.push(check_box);
	}
	
	var fieldset = "";
	var opt_showhide_class = (li>0) ? 'class="show-hide-lang"' : "";

	if (li==1) {
	    fieldset += '<button id="show-hide-lang">Show other languages ...</button>';
	}
	
	fieldset += '<fieldset ' + opt_showhide_class + '>\n';
	fieldset += legend;
	fieldset += '  <div id="'+l+'-pos-choice">\n';

	var check_box_join = check_box_list.join('&nbsp;');
	fieldset += check_box_join;
	
	fieldset += '  </div>\n';
	fieldset += '</fieldset>\n';
	
	$pos_fieldsets.append(fieldset);
	$('#'+l+'-enabled').click(lang_pos_toggle);

	if (l == "en") {
	    $('#en-pos-choice *').prop('disabled',false);
	}
	else {
	    $('#'+l+'-pos-choice *').prop('disabled',true);
	}
    }

    show_hide_lang()
}

function show_hide_lang()
{
    $( "#show-hide-lang" ).click(function(event) {
	event.preventDefault(); 
	if($('.show-hide-lang:visible').length) {
	    $('.show-hide-lang').hide("slide", {direction: "up" } , 1000);
	    $('#show-hide-lang').html("Show other languages ...");
	}
	else {
	    $('.show-hide-lang').show("slide", {direction: "up" } , 1000);
	    $('#show-hide-lang').html("Hide other languages ...");
	}
    });
}

function generate_other_langs()
{
    // setup other languages
    // for each 'langs_without_pos' generate HTML of the form:
    //    <input type="checkbox" name="fr-enabled" id="fr-enabled" />French
    var $other_langs = $('#other-langs');

    for (var i=0; i<langs_without_pos.length; i++) {
	var lang = langs_without_pos[i];
	var labeled_checkbox = '<nobr>';
	
	labeled_checkbox += '<input type="checkbox" name="'+lang+'-enabled" id="'+lang+'-enabled" />';
	/*
	if (lang === "zh-cn") {
	    console.log("Mapping zh-cn => zh");
	    lang = "zh";
	}
	if (lang === "zh-tw") {
	    console.log("Mapping zh-tw => zh");
	    lang = "zh";
	}
*/
	var lang_full = isoLangs[lang].name;
	var lang_native_full = isoLangs[lang].nativeName;
	var opt_title = (lang_full !== lang_native_full) ? 'title="'+lang_native_full+'"' : "";
	
	labeled_checkbox += '<label for="'+lang+'-enabled" style="padding-left: 5px; padding-right: 10px;" ' + opt_title + '>'+lang_full+'</label>';

	labeled_checkbox += '</nobr> ';
	
	$other_langs.append(labeled_checkbox);
	
    }
}

$(function() {
    generate_pos_langs();

    generate_other_langs();

    if ($('#search-submit').length>0) {
	$('#search-submit').click(submit_action);
    }
    
});
